#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>


#define PORT            5555
#define MESSAGE         "Yow!!! Hasta la vista, baby!"
#define SERVERHOST      "localhost"
#define MAXMSG  512


int make_socket(uint16_t port)
{
    int sock;
    struct sockaddr_in name;

    /* Create the socket. */
    sock = socket(PF_INET, SOCK_STREAM, 0);
    if (sock < 0) {
	perror("socket");
	exit(EXIT_FAILURE);
    }

    /* Give the socket a name. */
    name.sin_family = AF_INET;
    name.sin_port = htons(port);
    name.sin_addr.s_addr = htonl(INADDR_ANY);
    name.sin_port = htons(port);
    name.sin_addr.s_addr = htonl(INADDR_ANY);
    if (bind(sock, (struct sockaddr *) &name, sizeof(name)) < 0) {
	perror("bind");
	exit(EXIT_FAILURE);
    }

    return sock;
}

void
init_sockaddr(struct sockaddr_in *name,
	      const char *hostname, uint16_t port)
{
    struct hostent *hostinfo;

    name->sin_family = AF_INET;
    name->sin_port = htons(port);
    hostinfo = gethostbyname(hostname);
    if (hostinfo == NULL)
	if (hostinfo == NULL) {
	    fprintf(stderr, "Unknown host %s.\n", hostname);
	    exit(EXIT_FAILURE);
	}
    name->sin_addr = *(struct in_addr *) hostinfo->h_addr;
}

void write_to_server(int filedes)
{
    int nbytes;

    nbytes = write(filedes, MESSAGE, strlen(MESSAGE) + 1);
    if (nbytes < 0) {
	perror("write");
	exit(EXIT_FAILURE);
    }
}


int read_from_client(int filedes)
{
    char buffer[MAXMSG];
    int nbytes;

    nbytes = read(filedes, buffer, MAXMSG);
    if (nbytes < 0) {
	/* Read error. */
	perror("read");
//	exit(EXIT_FAILURE);
    } else if (nbytes == 0)
	/* End-of-file. */
	return -1;
    else {
	/* Data read. */
	fprintf(stderr, "Server: got message: `%s'\n", buffer);
	return 0;
    }
}

int main(void)
{
    extern void init_sockaddr(struct sockaddr_in *name,
			      const char *hostname, uint16_t port);
    int sock;
    char i;
    struct sockaddr_in servername;

    /* Create the socket. */
    sock = socket(PF_INET, SOCK_STREAM, 0);
    if (sock < 0) {
	perror("socket (client)");
	exit(EXIT_FAILURE);
    }

    /* Connect to the server. */
    init_sockaddr(&servername, SERVERHOST, PORT);
    if (0 > connect(sock,
		    (struct sockaddr *) &servername, sizeof(servername))) {
	perror("connect (client)");
	exit(EXIT_FAILURE);
    }

    /* Send data to the server. */
    while (1) {

	write_to_server(sock);


    if (read_from_client(sock) < 0) {
	close(sock);
//	FD_CLR(i, &active_fd_set);
    }

	getc(stdin);

    };

    close(sock);
    exit(EXIT_SUCCESS);
}
