//
// KUKAC jatek - szglab5 halozatok feladat
//
// (C)opyright by McRee [mcree@freemail.hu]
//

#include "globals.h"
#include "inetfunct.h"
#include <sys/time.h>
#include <stdio.h>
#include <signal.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <curses.h>

char MESSAGE[MAXMSG];

WINDOW *win;

t_players players[MAXPLAYERS];

t_level level;

int nn = 0;

int dir = DIR_LEFT;
bool gotkey = false;

int write_to_server(int filedes)
{
    int nbytes;
    int i;

    if (!gotkey) {
	i = getch();
	if (i != ERR) {
	    gotkey = true;
//          mvprintw(nn++, 15, "keypressed: %i", i);
	    switch (i) {
	    case KEY_UP:
		dir = DIR_UP;
		break;
	    case KEY_DOWN:
		dir = DIR_DOWN;
		break;
	    case KEY_LEFT:
		dir = DIR_LEFT;
		break;
	    case KEY_RIGHT:
		dir = DIR_RIGHT;
		break;
	    };
	};
    };

    sprintf(MESSAGE, "%i", dir);

    nbytes = write(filedes, MESSAGE, strlen(MESSAGE) + 1);
    if (nbytes < 0) {
	cclosescr();
	perror("write");
	exit(EXIT_FAILURE);
    }

    return nbytes;

}

#define XORG 1
#define YORG 1

void cl_killplayer(u)
{
    int ii, uu;

    for (uu = 0; uu < MAX_Y; uu++) {
	for (ii = 0; ii < MAX_X; ii++) {
	    if (level[ii][uu] == u) {
		level[ii][uu] = 0;
		move(uu + YORG, ii + XORG);
		color_set(20, NULL);
		addch('.');

	    };

	};
    };
};

int read_from_server(int filedes)
{
//    char buffer[MAXMSG];
    int nbytes, u, uu, ii;

    nbytes = read(filedes, players, MAXMSG);
//    nbytes = read(filedes, buffer, MAXMSG);
    if (nbytes < 0) {
	// Read error
	perror("client: read from server");
//      exit(EXIT_FAILURE);
    } else if (nbytes == 0)
	// End-of-file
	return -1;
    else {
	// Data read.
//      fprintf(stderr, "client: got message: `%s'\n", buffer);

//      fprintf(stderr, "client: recv: message size: %i\n", nbytes);

	gotkey = false;

	// timeout disconnected players
	for (u = 0; u < MAXPLAYERS; u++) {
	    if (players[u].disconn > 0)
		cl_killplayer(u);
	};

	// display frags and score
	for (u = 0; u < MAXPLAYERS; u++) {
	    color_set(u + 1, NULL);
	    mvprintw(0, 30 + u * 4, "%4.1i", players[u].lives);
	    mvprintw(MAX_Y + 1, 2 + u * 6, "%6.1i", players[u].score);
	};

	for (u = 0; u < MAXPLAYERS; u++) {
	    if (players[u].player != 0) {
		fprintf(stderr,
			"client: registered player %i (slot %i): x=%i y=%i dir=%i action=%i lives=%i score=%i\n",
			players[u].player, u, players[u].x, players[u].y, players[u].dir, players[u].action,
			players[u].lives, players[u].score);

		if (players[u].action == ACT_GO) {
		    color_set(u + 1, NULL);
		    move(players[u].y + YORG, players[u].x + XORG);
		    level[players[u].x][players[u].y] = u;
		    addch('+');
		    move(0, 0);
		} else if (players[u].action == ACT_INV) {
		    color_set(u + 1 + 8, NULL);
		    move(players[u].y + YORG, players[u].x + XORG);
		    level[players[u].x][players[u].y] = u;
		    addch('@');
		    move(0, 0);
		} else if (players[u].action == ACT_RESPAWN) {
		    color_set(u + 1, NULL);
		    move(players[u].y + YORG, players[u].x + XORG);
		    level[players[u].x][players[u].y] = u;
		    addch('+');
		    move(0, 0);
		    for (uu = 0; uu < MAX_Y; uu++) {
			for (ii = 0; ii < MAX_X; ii++) {
			    if (level[ii][uu] == u) {
//                              level[ii][uu] = 0;
				move(uu + YORG, ii + XORG);
				color_set(u + 1, NULL);
				addch('+');

			    };

			};
		    };
		} else {
/*		    for (uu = 0; uu < MAX_Y; uu++) {
			for (ii = 0; ii < MAX_X; ii++) {
			    if (level[ii][uu] == u) {
				level[ii][uu] = 0;
				move(uu, ii);
				color_set(20, NULL);
				addch('.');

			    };

			};
		    };
*/
		    cl_killplayer(u);

		};

	    };

	};

	return 0;
    }
}

void cinitscr(void)
{
    int i, x, y;

    win = initscr();
    start_color();

    cbreak();
    noecho();
    nodelay(win, true);

    nonl();
    intrflush(stdscr, FALSE);
    keypad(stdscr, TRUE);

    getmaxyx(win, y, x);

//    mvprintw(0, 10, "maxx,maxy: %i,%i", x, y);
//    mvprintw(1, 10, "has_colors: %i", has_colors());
//    mvprintw(2, 10, "can_change_color: %i", can_change_color());

    init_pair(1, COLOR_YELLOW, COLOR_RED);
    init_pair(2, COLOR_CYAN, COLOR_BLUE);
    init_pair(3, COLOR_YELLOW, COLOR_YELLOW);
    init_pair(4, COLOR_MAGENTA, COLOR_GREEN);
    init_pair(5, COLOR_GREEN, COLOR_MAGENTA);
    init_pair(6, COLOR_YELLOW, COLOR_BLUE);
    init_pair(7, COLOR_BLUE, COLOR_CYAN);
    init_pair(8, COLOR_GREEN, COLOR_YELLOW);

    init_pair(9, COLOR_WHITE, COLOR_RED);
    init_pair(10, COLOR_WHITE, COLOR_BLUE);
    init_pair(11, COLOR_WHITE, COLOR_YELLOW);
    init_pair(12, COLOR_WHITE, COLOR_GREEN);
    init_pair(13, COLOR_WHITE, COLOR_MAGENTA);
    init_pair(14, COLOR_WHITE, COLOR_BLUE);
    init_pair(15, COLOR_WHITE, COLOR_CYAN);
    init_pair(16, COLOR_WHITE, COLOR_YELLOW);

    init_pair(20, COLOR_BLACK, COLOR_BLACK);

    attrset(A_BOLD);

    win = subwin(win, MAX_Y + 2, MAX_X + 2, 0, 0);

    box(win, 0, 0);

    mvprintw(0, 1, "[KUKAC 1.0 by McRee]");

//                COLOR_BLACK
//             COLOR_RED
//                  COLOR_GREEN
//               COLOR_YELLOW
//                COLOR_BLUE
//             COLOR_MAGENTA
//            COLOR_CYAN

    refresh();
    doupdate();
    redrawwin(win);

};

void cclosescr(void)
{
    delwin(win);

    endwin();
};

int client(char *SERVERHOST)
{
    int nbytes, u;
    struct sockaddr_in servername;
    volatile int cl_sock;

    fd_set active_fd_set, read_fd_set, write_fd_set;	// file descriptor sets
    int i;			// dummy
    struct timespec clienttick, remaining;	// size one server tick

    // wait for server to start (in case of localhost)
    sleep(1);

    fprintf(stderr, "client: connecting to '%s'\n", SERVERHOST);

    memset(&players, 0, sizeof(t_players) * MAXPLAYERS);	// clear players table

    // setup default client delay
    clienttick.tv_sec = 0;
    clienttick.tv_nsec = 2000000;	// nsec must be <1000000000

    // Create the socket
    cl_sock = socket(PF_INET, SOCK_STREAM, 0);
    if (cl_sock < 0) {
	cclosescr();
	perror("socket (client)");
	exit(EXIT_FAILURE);
    }
    // Connect to the server
    init_sockaddr(&servername, SERVERHOST, PORT);
    if (0 > connect(cl_sock, (struct sockaddr *) &servername, sizeof(servername))) {
	cclosescr();
	perror("connect (client)");
	exit(EXIT_FAILURE);
    }
    // Initialize the set of active sockets
    FD_ZERO(&active_fd_set);	// empty set
    FD_SET(cl_sock, &active_fd_set);	// insert our socket to the set (we accept connections on it)

    fprintf(stderr, "client: successfully connected to server\n");

    cinitscr();

    // fetch current level state
    nbytes = read(cl_sock, level, MAXMSG);
    if (nbytes < 0) {		// Read error.
	cclosescr();
	perror("client: read from server");
	exit(EXIT_FAILURE);
    } else if (nbytes == 0)	// End-of-file.
	return -1;
    else {			// Data read.
	fprintf(stderr, "client: recv: message size: %i\n", nbytes);

	// build strating map
	for (i = 0; i < MAX_Y; i++) {
	    for (u = 0; u < MAX_X; u++) {
		if (level[u][i] != 0) {
		    color_set(level[u][i] + 1, NULL);
		    move(i + YORG, u + XORG);
		    addch('+');
		};
	    };
	};
    };


    /* Send data to the server. */
    while (1) {

	read_fd_set = active_fd_set;
	write_fd_set = active_fd_set;

	nanosleep(&clienttick, &remaining);

	if (select(FD_SETSIZE, &read_fd_set, &write_fd_set, NULL, 0) < 0) {
	    cclosescr();
	    perror("client: select");
	    exit(EXIT_FAILURE);
	}
	// Service all the sockets with output pending.
	for (i = 0; i < FD_SETSIZE; ++i)
	    if (FD_ISSET(i, &read_fd_set)) {
		if (read_from_server(i) < 0) {
		    cclosescr();
		    fprintf(stderr, "client: client connection lost\n");
		    close(i);
		    exit(EXIT_FAILURE);
		};
	    }
	// Service all the sockets with output pending.
	for (i = 0; i < FD_SETSIZE; ++i)
	    if (FD_ISSET(i, &write_fd_set)) {
		if (write_to_server(i) < 0) {
		    cclosescr();
		    fprintf(stderr, "client: client connection lost\n");
		    close(i);
		    exit(EXIT_FAILURE);
		};
	    }

    };

    cclosescr();
    close(cl_sock);
    exit(EXIT_SUCCESS);
}
