//
// KUKAC jatek - szglab5 halozatok feladat
//
// (C)opyright by McRee [mcree@freemail.hu]
//

#include "globals.h"
#include <sys/time.h>
#include <stdio.h>
#include <signal.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

void init_sockaddr(struct sockaddr_in *name, const char *hostname, uint16_t port)
{
    struct hostent *hostinfo;

    name->sin_family = AF_INET;
    name->sin_port = htons(port);
    hostinfo = gethostbyname(hostname);
    if (hostinfo == NULL)
	if (hostinfo == NULL) {
	    fprintf(stderr, "Unknown host %s.\n", hostname);
	    exit(EXIT_FAILURE);
	}
    name->sin_addr = *(struct in_addr *) hostinfo->h_addr;
}

int make_socket(uint16_t port)
{
    int sock;
    int opt = 1;
    struct sockaddr_in name;

    // Create the socket.
    sock = socket(PF_INET, SOCK_STREAM, 0);
    if (sock < 0) {
	perror("socket");
	exit(EXIT_FAILURE);
    }
    // set socket to keepalive connection mode
    if (setsockopt(sock, SOL_SOCKET, SO_KEEPALIVE, &opt, sizeof(int))) {
	perror("setsockopt");
	exit(EXIT_FAILURE);
    };

    // set socket to enable reuse address mode
    if (setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, &opt, sizeof(int))) {
	perror("setsockopt");
	exit(EXIT_FAILURE);
    };

    // give the socket a name (bind to port)
    name.sin_family = AF_INET;
    name.sin_port = htons(port);
    name.sin_addr.s_addr = htonl(INADDR_ANY);
    name.sin_port = htons(port);
    name.sin_addr.s_addr = htonl(INADDR_ANY);
    if (bind(sock, (struct sockaddr *) &name, sizeof(name)) < 0) {
	perror("bind");
	exit(EXIT_FAILURE);
    }

    return sock;

}
