//
// KUKAC jatek - szglab5 halozatok feladat
//
// (C)opyright by McRee [mcree@freemail.hu]
//

#include "globals.h"
#include "server.h"
#include <stdio.h>
#include <stdlib.h>

#include <sys/time.h>
#include <stdio.h>
#include <signal.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>

volatile pid_t pid_server;
volatile sig_atomic_t fatal_error_in_progress = 0;	// azert sig_atomic_t, hogy iras es olvasas kozben ne legyen gaz...

void sigh_main(int sig)
{
    /* Since this handler is established for more than one kind of signal,
       it might still get invoked recursively by delivery of some other kind
       of signal.  Use a static variable to keep track of that. */
    if (fatal_error_in_progress)
	raise(sig);
    fatal_error_in_progress = 1;

    /* Now do the clean up actions:
       - reset terminal modes
       - kill child processes
       - remove lock files */

    fprintf(stderr, "main: caught signal\n");

//    runserver = 0;

    kill(pid_server, SIGQUIT);	// server should receive this signal automatically, but we just care 8)

    cclosescr();

//    fprintf(stderr, "client: closing socket\n");

//    if(shutdown(cl_sock,2)) {
//      perror("close socket");
//    } else {
//      fprintf(stderr, "client: done\n");
//    };

    /* Now reraise the signal.  We reactivate the signal's
       default handling, which is to terminate the process.
       We could just call `exit' or `abort',
       but reraising the signal sets the return status
       from the process correctly. */
    signal(sig, SIG_DFL);
    raise(sig);
}

int main(int argc, char *argv[])
{
    char *hostname;

    fprintf(stderr, "main: kukac starting...\n");

    // setup signal handling
    signal(SIGTERM, sigh_main);
    signal(SIGINT, sigh_main);
    signal(SIGQUIT, sigh_main);
    signal(SIGHUP, sigh_main);
    signal(SIGKILL, sigh_main);

    if ((argc > 2) && (!strcmp(argv[2], "-d"))) {	// run in dedicated server mode
	fprintf(stderr, "main: received dedicated mode command. enabling debug output.\n");
    } else {
	fprintf(stderr, "main: not running in dedicated mode. disabling debug output.\n");
	stderr = freopen("/dev/null", "w", stderr);
    };

    if (argc < 2) {
	hostname = "localhost";
	fprintf(stderr, "main: no hostname given: using 'localhost' instead\n");
    } else {
	hostname = argv[1];
    };

    if (!strcmp(hostname, "localhost")) {
	fprintf(stderr, "main: connect to local host: attempting to start server\n");

	// ------------- FORK HERE --------------
	pid_server = fork();
	// ------------- FORK HERE --------------

	if (pid_server == -1) {
	    perror("main: fork");
	    exit(EXIT_FAILURE);
	};

	if (pid_server == 0) {	// we are running server
	    server();
	    fprintf(stderr, "server: exiting unexpectedly (this should not happen)\n");
	    exit(EXIT_FAILURE);
	};

    };


    if ((argc > 2) && (!strcmp(argv[2], "-d"))) {	// run in dedicated server mode
	fprintf(stderr, "main: running in dedicated server mode (CTRL-C to exit)\n");
	while (1) {
	};
    } else {
	fprintf(stderr, "main: initiating client connection to '%s'\n", hostname);
	client(hostname);
    };

    fprintf(stderr, "main: kukac finishing...\n");
    fprintf(stderr, "main: done.\n");
    exit(EXIT_SUCCESS);
};
